; 
    include \masm32\include\masm32rt.inc
; 
    .data
        hInst     dd          0
        hWnd      dd          0
        hIcon     dd          0
        wc        WNDCLASSEX  <>
        msg       MSG         <>
        className db          "minimal_gui",0
    .code
; 
start:
; 
    mov   hInst, rv(GetModuleHandle, NULL)
    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInst
    mov   wc.hbrBackground, rv(GetStockObject, BLACK_BRUSH)
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov   wc.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("Minimal GUI"),
                            WS_OVERLAPPEDWINDOW,
                            0,0,600,400,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd    
  msgLoop:
    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF (eax != 0)
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp   msgLoop
    .ENDIF
    exit msg.wParam
; 
WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    nops 3
    SWITCH uMsg
      CASE WM_CREATE
        invoke LoadImage, NULL, chr$("clock.ico"),
                          IMAGE_ICON, 0, 0, LR_LOADFROMFILE
        mov hIcon, eax
        invoke SetTimer, hWin, 1, 3000, NULL
      CASE WM_TIMER
        invoke SetClassLong, hWin, GCL_HICON, hIcon
      CASE WM_DESTROY
        invoke PostQuitMessage, NULL
        return 0
    ENDSW
    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret
WndProc endp
; 
end start
